# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: auth.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class LoginCall(betterproto.Message):
    username: str = betterproto.string_field(1)
    password: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LogoutCall(betterproto.Message):
    user_id: "_common__.UserId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LoginResponse(betterproto.Message):
    token: str = betterproto.string_field(1)
    user: "_user__.User" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LogoutResponse(betterproto.Message):
    successful: bool = betterproto.bool_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class AuthServiceCall(betterproto.Message):
    login_call: "LoginCall" = betterproto.message_field(1, group="message")
    logout_call: "LogoutCall" = betterproto.message_field(2, group="message")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class AuthServiceResponse(betterproto.Message):
    login_response: "LoginResponse" = betterproto.message_field(1, group="message")
    logout_respone: "LogoutResponse" = betterproto.message_field(2, group="message")

    def __post_init__(self) -> None:
        super().__post_init__()


class AuthStub(betterproto.ServiceStub):
    async def login(self, *, username: str = "", password: str = "") -> "LoginResponse":

        request = LoginCall()
        request.username = username
        request.password = password

        return await self._unary_unary("/auth.Auth/Login", request, LoginResponse)

    async def logout(self, *, user_id: "_common__.UserId" = None) -> "LogoutResponse":

        request = LogoutCall()
        if user_id is not None:
            request.user_id = user_id

        return await self._unary_unary("/auth.Auth/Logout", request, LogoutResponse)


from .. import common as _common__
from .. import user as _user__
